<?php
/*************************************************************************************/
/*                                                                                                                             */
/*      Module  pour Thelia                                                                                            */
/*                                                                                                                             */
/*      Copyright (c) Informatique Prog                                                                           */
/*      email : contact@informatiqueprog.net                                                                   */
/*                                                                                                                             */
/*      This program is free software; you can redistribute it and/or modify                       */
/*      it under the terms of the GNU General Public License as published by                      */
/*      the Free Software Foundation; either version 2 of the License, or                            */
/*      (at your option) any later version.                                                                         */
/*                                                                                                                              */
/*      This program is distributed in the hope that it will be useful,                                   */
/*      but WITHOUT ANY WARRANTY; without even the implied warranty of                    */
/*      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             */
/*      GNU General Public License for more details.                                                         */
/*                                                                                                                             */
/*      You should have received a copy of the GNU General Public License                           */
/*      along with this program; if not, write to the Free Software                                     */
/*      Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA               */
/*                                                                                                                             */
/*************************************************************************************/
?>
<?php

include_once(realpath(dirname(__FILE__)) . "/../../../classes/PluginsClassiques.class.php");

class Suivantprecedent extends PluginsClassiques{

    function Suivantprecedent(){
        $this->PluginsClassiques();
    }

    function boucle($texte, $args){
            /*** Listes ***/
        $listeChoix = array("produit", "rubrique");
        $listePosition = array("precedent", "suivant");
            /*** rcupration des arguments ***/
        $id = lireTag($args, "id");
        $choix = lireTag($args, "choix");
        $position = lireTag($args, "position");
            /*** contrle des paramtres ***/
        if(empty($id) || !in_array($choix, $listeChoix) || !in_array($position, $listePosition)) return "";

        switch ($choix){
            case "rubrique" :
                $parent = lireTag($args, "parent");
                $ligne = lireTag($args, "ligne");
                $classement = lireTag($args, "classement");
                $aleatoire = lireTag($args, "aleatoire");
                $exclusion = lireTag($args, "exclusion");
                $deb = lireTag($args, "deb");
                $num = lireTag($args, "num");

                $res="";
                $search="";
                $limit="";
                if(!$deb) $deb=0;
                if($ligne == "") $ligne="1";

                $rubrique = new Rubrique();
                $rubriquedesc = new Rubriquedesc();

                $search.=" and $rubrique->table.ligne=\"$ligne\"";
                if($parent!="") $search.=" and $rubrique->table.parent in ($parent)";
                if($num!="") $limit .= " limit $deb,$num";
                if($exclusion!="") $search .= " and $rubrique->table.id not in($exclusion)";
                $search .= " and lang=" . $_SESSION['navig']->lang;

                if($aleatoire) $order = "order by "  . " RAND()";
                else if($classement == "alpha") $order = "order by $rubriquedesc->table.titre";
                else if($classement == "alphainv") $order = "order by $rubriquedesc->table.titre desc";
                else $order = "order by $rubrique->table.classement";

                $query = "select $rubrique->table.id from $rubrique->table,$rubriquedesc->table where $rubrique->table.id=$rubriquedesc->table.rubrique $search $order $limit";
                $resul = mysql_query($query, $rubrique->link);

                $nbres = mysql_num_rows($resul);
                if(!$nbres) return "";
                $precedentId = 0;
                $suivantId = false;
                while($row = mysql_fetch_object($resul)){
                        /*** Cherche precedent et suivant ***/
                    if ( ($position == "precedent" && $row->id == $id && $precedentId != 0) || $suivantId){
                        if ($suivantId) $rubrique->charger($row->id);
                        else $rubrique->charger($precedentId);
                        $rubriquedesc = new Rubriquedesc();
                        $rubriquedesc->charger($rubrique->id, $_SESSION['navig']->lang);
                        $temp = str_replace("#ID", "$rubrique->id", $texte);
                        $temp = str_replace("#REF", "", $temp);
                        $temp = str_replace("#TITRE", "$rubriquedesc->titre", $temp);
                        $temp = str_replace("#URL", "rubrique.php?id_rubrique=" . "$rubrique->id", $temp);
                        $temp = str_replace("#REWRITEURL", rewrite_rub("$rubrique->id"), $temp);
                        if(trim($temp) != "") $res .= $temp;
                        break;
                    }
                    else if ($position == "suivant" && $row->id == $id) $suivantId = true;
                    else $precedentId = $row->id;
                }
            break;
            case "produit" :
                $rubrique = lireTag($args, "rubrique");
                $ligne = lireTag($args, "ligne");
                $nouveaute = lireTag($args, "nouveaute");
                $promo = lireTag($args, "promo");
                $garantie = lireTag($args, "garantie");
                $motcle = lireTag($args, "motcle");
                $classement = lireTag($args, "classement");
                $aleatoire = lireTag($args, "aleatoire");
                $prixmin = lireTag($args, "prixmin");
                $prixmax = lireTag($args, "prixmax");
                $caracteristique = lireTag($args, "caracteristique");
                $caracdisp = lireTag($args, "caracdisp");
                $caracval = lireTag($args, "caracval");
                $typech = lireTag($args, "typech");
                $declinaison = lireTag($args, "declinaison");
                $declidisp = lireTag($args, "declidisp");
                $declival = lireTag($args, "declival");
                $declistockmini = lireTag($args, "declistockmini");
                $stockmini = lireTag($args, "stockmini");
                $profondeur = lireTag($args, "profondeur");
                $exclusion = lireTag($args, "exclusion");
                $exclurub = lireTag($args, "exclurub");
                $poids = lireTag($args, "poids");
                $stockvide = lireTag($args, "stockvide");

                $search = "";
                $order = "";
                $limit="";
                $res="";
                $virg="";

                if($exclusion!="") $search .= " and id not in($exclusion)";
                if($exclurub!="") $search .= " and rubrique not in($exclurub)";
                
                if($rubrique!=""){
                    $srub = "";
                    if($profondeur == "") $profondeur=0;
                    $tabrub = explode(",", $rubrique);
                    for($compt = 0; $compt<count($tabrub); $compt++){
                        $rec = arbreBoucle($tabrub[$compt], $profondeur);
                        if(substr($rec, strlen($rec)-1) == ",") $rec = substr($rec, 0, strlen($rec)-1);
                        if($rec) $virg = ",";
                        $srub .= $tabrub[$compt] . $virg . $rec . $virg;
                    }
                    if(substr($srub, strlen($srub)-1) == ",")
                        $srub = substr($srub, 0, strlen($srub)-1);
                     $search .= " and rubrique in($srub)";
                }

                if($ligne == "") $ligne="1";
                $search .= " and ligne=\"$ligne\"";
                if($nouveaute!="") $search .= " and nouveaute=\"$nouveaute\"";
                if($promo!="") $search .= " and promo=\"$promo\"";
                if($garantie!="") $search .= " and garantie=\"$garantie\"";
                if($prixmin!="") $search .= " and ((prix2>=\"$prixmin\" and promo=\"1\") or (prix>=\"$prixmin\" and promo=\"0\"))";
                if($prixmax!="") $search .= " and ((prix2<=\"$prixmax\" and promo=\"1\") or (prix<=\"$prixmax\" and promo=\"0\"))";
                if($poids!="") $search .= " and poids<=\"$poids\"";
                if($stockmini!="" && $declistockmini == "") $search .= " and stock>=\"$stockmini\"";
                if (""!=$stockvide) {
                    if (0 < $stockvide) { $search .= " and stock<=\"0\""; }
                    elseif (0 >= $stockvide) { $search .= " and stock>\"0\""; }
                }

                if($aleatoire) $order = "order by "  . " RAND()";
                else if($classement == "prixmin") $order = "order by "  . " prix";
                else if($classement == "prixmax") $order = "order by "  . " prix desc";
                else if($classement == "rubrique") $order = "order by "  . " rubrique";
                else if($classement == "manuel") $order = "order by classement";
                else if($classement == "inverse") $order = "order by classement desc";
                else if($classement == "date") $order = "order by datemodif desc";
                else if($classement == "titre") $order = "order by titre";
                else if($classement == "titreinverse") $order = "order by titre desc";
                else if($classement == "ref") $order = "order by ref";
                else if($classement == "promo") $order = "order by promo desc";
                else $order = "order by classement";

                $produit = new Produit();
                if($caracdisp != ""){
                    if(! strstr($caracteristique, "-")) $caracteristique .= "-";
                    if(! strstr($caracdisp, "-")) $caracdisp .= "-";
                    $lcaracteristique = explode("-", $caracteristique);
                    $lcaracdisp = explode("-", $caracdisp);
                    $i = 0;
                    $tcaracval = new Caracval();
                    while($i<count($lcaracteristique)-1){
                        $caracteristique = $lcaracteristique[$i];
                        $caracdisp = $lcaracdisp[$i];
                        if($caracdisp == "*")
                            $query = "select * from $tcaracval->table where caracteristique='$caracteristique' and caracdisp<>''";
                        else if($caracdisp == "-")
                            $query = "select * from $tcaracval->table where caracteristique='$caracteristique' and caracdisp=''";
                        else $query = "select * from $tcaracval->table where caracteristique='$caracteristique' and caracdisp='$caracdisp'";
                        $resul = mysql_query($query);
                        if(!mysql_num_rows($resul)) return;
                        $liste="";
                        while($row = mysql_fetch_object($resul))
                            $liste .= "'$row->produit', ";
                        $liste = substr($liste, 0, strlen($liste) - 2);
                        $i++;
                        if($liste!="") $search .= " and $produit->table.id in($liste)";	
                        else return "";
                    }
                }
                if($caracval != ""){
                    $i = 0;
                    $liste="";
                    $tcaracval = new Caracval();
                    if($caracval == "*") $query = "select * from $tcaracval->table where caracteristique='$caracteristique' and valeur<>''";
                    else if($caracval == "-") $query = "select * from $tcaracval->table where caracteristique='$caracteristique' and valeur=''";
                    else if($typech == "like") $query = "select * from $tcaracval->table where caracteristique='$caracteristique' and valeur like '$caracval'";
                    else $query = "select * from $tcaracval->table where caracteristique='$caracteristique' and valeur ='$caracval'";
                    $resul = mysql_query($query);
                    $liste="";
                    while($row = mysql_fetch_object($resul))
                        $liste .= "'$row->produit', ";
                    $liste = substr($liste, 0, strlen($liste) - 2);
                    $i++;
                    if($liste!="") $search .= " and $produit->table.id in($liste)";	
                    else return "";
                }
                if($declidisp != ""){
                    if(! strstr($declinaison, "-")) $declinaison .= "-";
                    if(! strstr($declidisp, "-")) $declidisp .= "-";
                    if(! strstr($ldeclistockmini, "-")) $ldeclistockmini .= "-";
                    $ldeclinaison = explode("-", $declinaison);
                    $ldeclidisp = explode("-", $declidisp);
                    $ldeclistockmini = explode("-", $declistockmini);
                    $i = 0;
                    $liste="";
                    $exdecprod = new Exdecprod();
                    $stock = new Stock();
                    while($i<count($ldeclinaison)-1){
                        $declinaison = $ldeclinaison[$i];
                        $declidisp = $ldeclidisp[$i];
                        $declistockmini = $ldeclistockmini[$i];
                        $query = "select * from $exdecprod->table where declidisp='$declidisp'";
                        $resul = mysql_query($query);
                        if(mysql_num_rows($resul))
                            while($row = mysql_fetch_object($resul))
                                $liste .= "'$row->produit', ";
                        if($liste!="") {
                            $liste = substr($liste, 0, strlen($liste) - 2);
                            $search .= " and $produit->table.id not in($liste)";
                        }
                        $liste="";
                        if($declistockmini != ""){
                            $query = "select * from $stock->table where declidisp='$declidisp' and valeur>='$declistockmini'";
                            $resul = mysql_query($query);
                            if(mysql_num_rows($resul)) 
                                while($row = mysql_fetch_object($resul))
                                    $liste .= "'$row->produit', ";
                            if($liste!="") {
                                $liste = substr($liste, 0, strlen($liste) - 2);
                                $search .= " and $produit->table.id in($liste)";
                            } else return "";
                        }
                        $i++;
                    }
                }
                $produit = new Produit();
                $produitdesc = new Produitdesc();
                if($motcle){
                    $motcle = strip_tags($motcle);
                    $liste="";
                    $query = "select * from $produitdesc->table  LEFT JOIN $produit->table ON $produit->table.id=$produitdesc->table.produit WHERE $produit->table.ref='$motcle' or titre like '% $motcle%' or titre like '%$motcle %' OR titre='$motcle' OR chapo like '% $motcle%' OR chapo like '%$motcle %' OR description like '% $motcle%' OR description like '%$motcle %' OR postscriptum like '% $motcle%' OR postscriptum like '%$motcle %'";
                    $resul = mysql_query($query, $produitdesc->link);
                    $nbres = mysql_num_rows($resul);
                    if(!$nbres) return "";
                    while( $row = mysql_fetch_object($resul) ){
                        $liste .= "'$row->produit', ";
                    }
                    $liste = substr($liste, 0, strlen($liste) - 2);
                    $search .= "and $produit->table.id in ($liste)";
                }
                if($classement != "titre" && $classement != "titreinverse"){
                    $query = "select * from $produit->table where 1 $search $order $limit";
                    $classement = "produit";
                } else {
                    $query = "select * from $produit->table, $produitdesc->table where $produit->table.id=$produitdesc->table.produit and $produitdesc->table.lang=\"" . $_SESSION['navig']->lang . "\" $search $order $limit";
                    $classement = "produitdesc";
                }
                $resul = mysql_query($query, $produit->link);
                $nbres = mysql_num_rows($resul);
                if(!$nbres) return "";
                $precedentId = 0;
                $suivantId = false;
                while( $row = mysql_fetch_object($resul) ){
                    if($classement == "produit") $prodid = $row->id;
                    else $prodid = $row->produit.id;
                    if ( ($position == "precedent" && $prodid == $id && $precedentId != 0) || $suivantId){
                        if ($suivantId) {
                            $produit->charger_id($prodid);
                            $produitdesc->charger($prodid, $_SESSION['navig']->lang);
                        }
                        else {
                            $produit->charger_id($precedentId);
                            $produitdesc->charger($precedentId, $_SESSION['navig']->lang);
                        }
                        $temp = $texte;
                        $temp = str_replace("#ID", "$produit->id", $temp);
                        $temp = str_replace("#REF", "$produit->ref", $temp);
                        $temp = str_replace("#TITRE", "$produitdesc->titre", $temp);
                        $temp = str_replace("#URL", "produit.php?ref=" . "$produit->ref" . "&amp;id_rubrique=" . "$produit->rubrique", $temp);
                        $temp = str_replace("#REWRITEURL", rewrite_prod("$produit->ref"), $temp);
                        $res .= $temp;
                        break;
                    }
                    else if ($position == "suivant" && $prodid == $id) $suivantId = true;
                    else $precedentId = $prodid;
                }
                return $res;
            break;
            default:
            break;
        }
        return $res;
    }

}
?>